
open three ;

bind_st_thm ("threes",
    "[| $X |- $Y; $X |- @ $Y; $X |- *@* $Y |] ==> $X |- *@* @ $Y",
    [asm_rl, md1 blob, md1 sbs] MRS threea RS md2 blob RS md2 sbs) ;

(* to prove axiom .3 from rule .3 *)

val ax3 = prove_goal thy
    "$I |- wdm A & wdm B -> wdm (A & wdm B) v wdm (B & wdm A) v wdm (A & B)"
  (fn _ => [
    rtac imps 1,
    rtac mla 1,
    rtac anda 1,
    rtac ors 1,
    d_b_tac "-l" (rtac ors) 1,
    disp_tac "-lr" 1,
    rtac cS 1,
    disp_tac "|rlr" 1,
    rtac (md2 aS) 1,
    rtac (md1 pSe) 1,
    rtac (md2 aS) 1,
    d_b_tac "-r" (rtac (md2 aS)) 1,
    rtac (md2 aS) 1,
    rtac wdma 1,
    disp_tac "|*@*" 1,
    rtac sbsdists 1,
    d_b_tac "-r" (rtac wdmS) 1,
    d_b_tac "-r" (rtac andS) 1,
    rtac mls 1,
    rtac idf 1,
    disp_tac "-l*@*" 1,

    d_b_tac "-l" (rtac (md1 pSe)) 1,
    rtac (md1 aS) 1,
    disp_tac "-l*" 1,
    rtac wdma 1,
    disp_tac "|*@" 1,
    rtac bldista 1,
    d_b_tac "|r@" (rtac (md2 cbdista)) 1,
    d_b_tac "|r@l" (rtac (md2 cbdista)) 1,
    d_b_tac "|r" (rtac bldista) 1,
    d_b_tac "|rl" (rtac bldista) 1,

    disp_tac "|rx" 1,
    rtac (md2 cbdists) 1,
    d_b_tac "-r" (rtac (md2 cbdists)) 1,
    d_b_tac "-l" (rtac wdmS) 1,
    d_b_tac "-rl" (rtac wdmS) 1,
    d_b_tac "-rr" (rtac wdmS) 1,
    rtac (md2 cbdista) 1,
    d_b_tac "|l" (rtac (md1 ssA)) 1,
    d_b_tac "|r" (rtac (md1 ssA)) 1,

    d_b_tac "|r" (rtac threea) 1,
    d_b_tac "|r" (rtac mra) 1,
    rtac mrs 1,
    rtac ands 1, rtac idf 1, rtac idf 1,
    d_b_tac "|r" (rtac bldista) 1,
    d_b_tac "|r" (rtac mla) 1,
    disp_tac "|rx" 1,
    d_b_tac "|*" (rtac mrs) 1,
    rtac (md1 ssA) 1,
    rtac wdmS 1, rtac idf 1,
    d_b_tac "|r*@*" (rtac mra) 1,
    rtac mls 1, rtac mrs 1,
    rtac ands 1, rtac wdms 2,
    rtac idf 1, rtac idf 1]) ;

(*
val ax3a = prove_goal thy "$I |- wbx (wbx A -> wbx B) v wbx (wbx B -> wbx A)"
  (fn _ => [
  *)

use_thy "T" ; open T ;

val T3thy = merge_theories (T.thy, three.thy) ;

val ax3t = prove_goal T3thy "$I |- wbx (wbx A -> B) v wbx (wbx B -> A)"
  (fn _ => [
    glob_tac (tfpr (pr_append (pr_mod, pr_intr))) 1,
    disp_tac "-r" 1,
    glob_tac (tfpr pr_id) 1,
    d_b_tac "|*@r" (rtac (md2 ssS)) 1,
    d_b_tac "|*@" (rtac (md1 cbdists)) 1,
    rtac (md2 blob) 1,
    rtac threea 1,
    keep_tac ["|r", "-r"] 1,
    rtac (wbxa RS TS) 1,
    rtac idf 1,
    keep_tac ["|@r", "-r"] 1,
    rtac wbxA 1, rtac idf 1,
    keep_tac ["|*@*l", "-l"] 1,
    glob_tac (tfpr pr_ss) 1,
    rtac (md1 dcp) 1,
    rtac wbxa 1, rtac idf 1]) ;

