
open B ;

qed_goal "BR" thy "$Z |- @ (@ $X, $Y) ==> $Z |- $X, @ $Y"
  (fn [prem] => [
    disp_tac "|x" 1,
    rtac (md2 cbdista) 1,
    rtac (md1 pAe) 1,
    d_b_tac "|r*@" (rtac (md2 ssS)) 1,
    rtac BL 1,
    disp_tac "-*" 1,
    d_b_tac "-@" (rtac (md2 cbdists)) 1,
    d_b_tac "-@l" (rtac (md1 ssS)) 1,
    d_b_tac "-@r" (rtac (md1 ssS)) 1,
    d_b_tac "-@r@" (rtac (md1 ssS)) 1,
    d_b_tac "-@" (rtac (md1 pSe)) 1,
    rtac prem 1]) ;

(* prove B axiom from B rule *)

val axB = prove_goal thy "$I |- A -> wbx wdm A"
  (fn _ => [
    rtac imps 1,
    rtac mla 1,
    rtac wbxS 1,
    rtac ils 1,
    disp_tac "-l" 1,
    d_b_tac "|r*@" (rtac (md2 ssS)) 1,
    rtac BL 1,
    disp_tac "|*@*" 1,
    rtac nS 1,
    disp_tac "|r*" 1,
    d_b_tac "|*" (rtac mrs) 1,
    rtac wdms 1,
    rtac idf 1]) ;

(* prove alternative B axiom from B rule *)

val axB2 = prove_goal thy "$I |- A & wdm B -> wdm (B & wdm A)"
  (fn _ => [
    rtac imps 1,
    glob_tac (tfpr (pr_appl [pr_id, pr_intr, pr_mod])) 1,
    rtac BL 1,
    rtac wdms 1,
    rtac (md1 pAe) 1,
    rtac ands 1,
    rtac wdms 2,
    rtac idf 1, rtac idf 1]) ;
